#include <iostream>
#include <vector>
#include <string>

using namespace std;

struct grupe {
	int o, a, b, ab;
};

int main()
{
	int n;
	grupe ostatak;

	string grupa;
	int kolicina;

	vector<grupe> rezultat;

	bool moguce = true;

	cin >> n >> ostatak.o >> ostatak.a >> ostatak.b >> ostatak.ab;

	for (int i = 0; i < n; i++)
	{
		cin >> grupa >> kolicina;

		grupe oduzimanje = {0, 0, 0, 0};

		if (grupa == "O")
		{
			ostatak.o -= kolicina;
			oduzimanje.o = kolicina;
		}
		else if (grupa == "A")
		{
			if (ostatak.a >= kolicina)
			{
				ostatak.a -= kolicina;
				oduzimanje.a = kolicina;
			}
			else
			{
				kolicina -= ostatak.a;
				oduzimanje.a = ostatak.a;
				ostatak.a = 0;
				
				ostatak.o -= kolicina;
				oduzimanje.o = kolicina;
			}
		}
		else if (grupa == "B")
		{
			if (ostatak.b >= kolicina)
			{
				ostatak.b -= kolicina;
				oduzimanje.b = kolicina;
			}
			else
			{
				kolicina -= ostatak.b;
				oduzimanje.b = ostatak.b;
				ostatak.b = 0;

				ostatak.o -= kolicina;
				oduzimanje.o = kolicina;
			}
		}
		else if(grupa == "AB")
		{
			if (ostatak.ab >= kolicina)
			{
				ostatak.ab -= kolicina;
				oduzimanje.ab = kolicina;
			}
			else
			{
				kolicina -= ostatak.ab;
				oduzimanje.ab = ostatak.ab;
				ostatak.ab = 0;

				if (ostatak.a >= kolicina)
				{
					ostatak.a -= kolicina;
					oduzimanje.a = kolicina;
				}
				else
				{
					kolicina -= ostatak.a;
					oduzimanje.a = ostatak.a;
					ostatak.a = 0;

					if (ostatak.b >= kolicina)
					{
						ostatak.b -= kolicina;
						oduzimanje.b = kolicina;
					}
					else
					{
						kolicina -= ostatak.b;
						oduzimanje.b = ostatak.b;
						ostatak.b = 0;

						ostatak.o -= kolicina;
						oduzimanje.o -= kolicina;
					}
				}
			}
		}

		rezultat.push_back(oduzimanje);

		if (ostatak.o < 0)
		{
			moguce = false;
			break;
		}
	}

	if (moguce)
	{
		cout << "moguce" << endl;
		for (int i = 0; i < n; i++)
		{
			cout << rezultat[i].o << " " << rezultat[i].a << " " << rezultat[i].b << " " << rezultat[i].ab << endl;
		}
	}
	else
	{
		cout << "nemoguce";
	}
}